// src/internal/persistent-port.ts
import browser from "webextension-polyfill";
var createPersistentPort = (name = "") => {
  let port;
  const onMessageListeners = /* @__PURE__ */ new Set();
  const invokeOnMessageListeners = (message, port2) => {
    onMessageListeners.forEach((cb) => cb(message, port2));
  };
  const connect = () => {
    port = browser.runtime.connect({ name });
    port.onMessage.addListener(invokeOnMessageListeners);
    port.onDisconnect.addListener(connect);
  };
  connect();
  return {
    onMessage(cb) {
      onMessageListeners.add(cb);
    },
    postMessage(message) {
      port.postMessage(message);
    }
  };
};

export {
  createPersistentPort
};
