import {
  encodeConnectionArgs
} from "./chunk-AFVNWE3J.js";

// src/internal/persistent-port.ts
import uid from "tiny-uid";
import browser from "webextension-polyfill";
var createPersistentPort = (name = "") => {
  const fingerprint = uid(12);
  let port;
  const onMessageListeners = /* @__PURE__ */ new Set();
  const invokeOnMessageListeners = (message, port2) => {
    onMessageListeners.forEach((cb) => cb(message, port2));
  };
  const connect = () => {
    console.log("connection at", new Date().toISOString());
    port = browser.runtime.connect({
      name: encodeConnectionArgs({
        endpointId: name,
        fingerprint
      })
    });
    port.onMessage.addListener(invokeOnMessageListeners);
    port.onDisconnect.addListener(() => {
      console.log("disconnected");
      connect();
    });
  };
  connect();
  return {
    onMessage(cb) {
      onMessageListeners.add(cb);
    },
    postMessage(message) {
      port.postMessage(message);
    }
  };
};

export {
  createPersistentPort
};
